//Language: CSS, Level1
//Copyright (c) 1992-2002 Altium Limited             
//All rights reserved.                               
//http://www.dream-com.com                           
//contact@dream-com.com                              

// states
State=snormal
State=sstring1
State=sstring2
State=sstring3
State=sstring4
State=scomment1
State=scomment2
State=scomment3
State=scomment4
State=sstyle
// tokens
Token=tnone
Token=tstring
Token=tcomment
Token=tident
Token=tinteger
Token=tfloat
Token=tresword
Token=tassembler
Token=turl
Token=twhitespace
Token=tdirective
//delims
Delimiters=;.,:'"{}[]()?!@#$%^&*-+=|\/

//idents
snormal   [a-z_A-Z][a-z_A-Z0-9]*  snormal   tident

//white space
snormal #32*                      snormal   twhitespace

//strings
snormal     \"                     sstring1   tstring
sstring1    [^\"]*                 sstring1   tstring
sstring1    \"                     snormal    tstring
sstring1    \"\"                   sstring1   tstring
sstring1    $                      snormal    tstring

//comments
snormal   <\!--                    scomment1 tcomment
scomment1 [^\-]*                   scomment1 tcomment
scomment1  -->                     snormal   tcomment

snormal   /\*                     scomment2 tcomment
scomment2 [^\*]*                  scomment2 tcomment
scomment2 \*[^/]                  scomment2 tcomment
scomment2 [\*]*/                  snormal   tcomment

//Common
snormal \{                          sstyle   tresword
sstyle  \}                          snormal  tresword

// reswords
sstyle 'align'       sstyle tresword
sstyle 'attachment'  sstyle tresword
sstyle 'auto'        sstyle tresword
sstyle 'background'  sstyle tresword
sstyle 'border'      sstyle tresword
sstyle 'bottom'      sstyle tresword
sstyle 'clear'       sstyle tresword
sstyle 'color'       sstyle tresword
sstyle 'decoration'  sstyle tresword
sstyle 'display'     sstyle tresword
sstyle 'family'      sstyle tresword
sstyle 'float'       sstyle tresword
sstyle 'font'        sstyle tresword
sstyle 'height'      sstyle tresword
sstyle 'image'       sstyle tresword
sstyle 'indent'      sstyle tresword
sstyle 'left'        sstyle tresword
sstyle 'letter'      sstyle tresword
sstyle 'line'        sstyle tresword
sstyle 'list'        sstyle tresword
sstyle 'margin'      sstyle tresword
sstyle 'padding'     sstyle tresword
sstyle 'position'    sstyle tresword
sstyle 'repeat'      sstyle tresword
sstyle 'right'       sstyle tresword
sstyle 'size'        sstyle tresword
sstyle 'space'       sstyle tresword
sstyle 'spacing'     sstyle tresword
sstyle 'style'       sstyle tresword
sstyle 'text'        sstyle tresword
sstyle 'through'     sstyle tresword
sstyle 'top'         sstyle tresword
sstyle 'transform'   sstyle tresword
sstyle 'type'        sstyle tresword
sstyle 'variant'     sstyle tresword
sstyle 'vertical'    sstyle tresword
sstyle 'weight'      sstyle tresword
sstyle 'white'       sstyle tresword
sstyle 'width'       sstyle tresword
sstyle 'word'        sstyle tresword

// numbers
sstyle [1-9][0-9]*                            sstyle  tinteger
sstyle \#[0-9A-F]+                            sstyle  tinteger
sstyle [1-9][0-9]*\.[0-9]*                    sstyle  tfloat
sstyle [1-9][0-9]*{\.[0-9]+}|e{[\+\-]}|[0-9]+ sstyle  tfloat

//idents
sstyle   [A-Z_a-z][0-9A-Z_a-z]*  sstyle   tident

//white space
sstyle #32*                      sstyle  twhitespace

//comments
sstyle    <\!--                    scomment3 tcomment
scomment3 [^\-]*                   scomment3 tcomment
scomment3  -->                     sstyle    tcomment

sstyle    /\*                     scomment4 tcomment
scomment4 [^\*]*                  scomment4 tcomment
scomment4 \*[^/]                  scomment4 tcomment
scomment4 [\*]*/                  sstyle    tcomment


//strings
sstyle      \"                     sstring3    tstring
sstring3    [^\"]*                 sstring3    tstring
sstring3    \"                     sstyle      tstring
sstring3    \"\"                   sstring3    tstring
sstring3    $                      sstyle      tstring

sstyle      \'                     sstring4    tstring
sstring4    [^\']*                 sstring4    tstring
sstring4    \'                     sstyle      tstring
sstring4    \'\'                   sstring4    tstring
sstring4    $                      sstyle      tstring
