//Language: XML
//Copyright (c) 1992-2002 Altium Limited             
//All rights reserved.                               
//http://www.dream-com.com                           
//contact@dream-com.com                              

// states
State=snormal
State=sstring1
State=scomment1
State=stag
State=sspecialtag
// tokens
Token=tnone
Token=tstring
Token=tcomment
Token=tident
Token=tinteger
Token=tfloat
Token=tresword
Token=tassembler
Token=turl
Token=twhitespace
//delims
Delimiters=;.,:'"{}[]()?!@#$%^&*-+=|\/

//Common
snormal <     stag  tresword
stag [^\>^\"] stag  tresword
stag >        snormal   tresword

//snormal  <[/a-z_A-Z][a-z_A-Z0-9]*  stag      tresword
//stag     [a-z_A-Z][a-z_A-Z0-9]*    stag      tident
//stag     >                         snormal   tresword


//white space
stag #32*                         stag   twhitespace

//strings
stag       \"                     sstring1   tstring
sstring1   [^\"]*                 sstring1   tstring
sstring1   \"                     stag       tstring
sstring1   \"\"                   sstring1   tstring
sstring1   $                      stag       tstring


//comments
snormal       <\!--                    scomment1 tcomment
scomment1  [^\-]*                   scomment1 tcomment
scomment1  -->                      snormal      tcomment

//idents
sspecialtag  [#1-#255]  sspecialtag  tresword


snormal        <\!\[CDATA\[          sspecialtag  tresword
sspecialtag    \]\]>                 snormal      tresword

snormal        <\?          sspecialtag  tresword
sspecialtag    \?>          snormal      tresword


