;InnoSetupVersion=3.0.5

[Setup]
AppName=CSE HTML Validator Professional
AppVerName=CSE HTML Validator Professional v6.01 Trial Version
AppId=CSEPRO60
AppPublisher=AI Internet Solutions
AppPublisherURL=http://www.htmlvalidator.com/
AppSupportURL=http://www.htmlvalidator.com/
AppUpdatesURL=http://www.htmlvalidator.com/
DefaultDirName={pf}\HTMLValidator60
DefaultGroupName=CSE HTML Validator Pro v6.0
OutputBaseFilename=csesetup
Compression=zip
PrivilegesRequired=none
LicenseFile=embedded\License.txt
InfoBeforeFile=embedded\InfoBefore.txt
WizardImageFile=embedded\WizardImage0.bmp
WizardSmallImageFile=embedded\WizardSmallImage0.bmp

[Files]
Source: "{app}\cse60.exe"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\batchreporttemplate.css"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\taginsertercfg.txt"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\cssinsertercfg.txt"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\userinsertercfg.txt"; DestDir: "{app}"; Flags: uninsneveruninstall onlyifdoesntexist 
Source: "{app}\htmlval.key"; DestDir: "{app}"; Flags: onlyifdoesntexist 
Source: "{app}\htmlval60.cfg"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\msgidcfg.xml"; DestDir: "{app}"; Flags: uninsneveruninstall onlyifdoesntexist 
Source: "{app}\license.txt"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\log.txt"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\output.txt"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\scratchpad1.txt"; DestDir: "{app}"; Flags: onlyifdoesntexist 
Source: "{app}\scratchpad2.txt"; DestDir: "{app}"; Flags: onlyifdoesntexist 
Source: "{app}\soundplayer.exe"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\cmdlineprocessor.exe"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{sys}\csevalidator.dll"; DestDir: "{sys}"; Flags: ignoreversion 
Source: "{app}\csevalidatorV60.dll"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\CSE HTML Validator Home Page.url"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\Ordering Information.url"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\Documentation\about.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\attributegroupseditor.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\attributeseditor.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\attributevalueseditor.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\categorieseditor.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\characterentitieseditor.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\commandlinearguments.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\configuration.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\contents.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\draganddropdefaulttoolselectdialogbox.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\editoreditortab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\editorfileoptionstab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\editorfiletypestab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\editorgeneralinfo.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\editorgeneraltab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\editorhtmltab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\findreplacedialog.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\gettingstarted.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\licenseagreement.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\messageids.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\noteseditor.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\orderinginformation.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\programlimitations.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\programseditor.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\quickref.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\resultswindowlinkstab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\settinguprightclickpopupmenus.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\spellchecking.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\tagnameseditor.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\templatetool.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\tipsforusinghtmlvalidator.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\uninstallinghtmlvalidator.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\usingthetools.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valengineaccessibilitytab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valengineclassictab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valengineflagstab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valenginegeneraltab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valengineloggingtab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valenginenetworktab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valenginestylestab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valenginetagnameprogramtab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valenginetoolstab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valenginevalidatortab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\valserverside.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\warranty.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\webbrowser.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\welcome.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\wizardlinkstab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\wizardmain.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\wizardoptionstab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\wizardreportingtab.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\wizardtargetlistformat.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\wizardtargetproperties.html"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\Documentation\docs.css"; DestDir: "{app}\Documentation"; Flags: ignoreversion 
Source: "{app}\ParserRules\asp(vbs)_html.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\assembler.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\awk_script.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\c#.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\c++builder.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\c.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\clarion.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\cliper.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\cobol.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\css_lev1.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\css_lev2.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\delphi.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\dfm_files.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\fortran.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\foxpro.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\html.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\ini_files.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\java.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\javascript_html.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\java_script.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\latex.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\microsoft_idl.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\modula2.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\ms_dosbl.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\oberon.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\perl.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\php_in_html.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\pl_sql.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\python.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\resourse_rs_files.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\rtf.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\sql_oracle.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\tcltk.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\unix_shell.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\vbs_script.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\vbs_script_html.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\vis_basic.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\xml.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\ParserRules\xml_with_scripts.xs"; DestDir: "{app}\ParserRules"; Flags: ignoreversion 
Source: "{app}\application.ico"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\applicationxp.ico"; DestDir: "{app}"; Flags: ignoreversion 
Source: "{app}\Dictionary\AIISAdd.adm"; DestDir: "{app}\Dictionary"; Flags: ignoreversion 
Source: "{app}\Dictionary\American.adm"; DestDir: "{app}\Dictionary"; Flags: ignoreversion 
Source: "{app}\Dictionary\FHTMLAdd.adm"; DestDir: "{app}\Dictionary"; Flags: ignoreversion 
Source: "{app}\Dictionary\HTMLAdd.adm"; DestDir: "{app}\Dictionary"; Flags: ignoreversion 
Source: "{sys}\vcl50.bpl"; DestDir: "{sys}"; Flags: sharedfile 
Source: "{app}\vcl50.bpl"; DestDir: "{app}"; 

[Registry]
Root: HKCU; Subkey: "Software\AI Internet Solutions\CSE 3310 HTML Validator"; ValueName: "ExternalCapability"; ValueType: String; ValueData: "7"; 
Root: HKCU; Subkey: "Software\AI Internet Solutions\CSE HTML Validator v4"; ValueName: "InstallDir"; ValueType: String; ValueData: "{app}"; 
Root: HKCU; Subkey: "Software\AI Internet Solutions\CSE HTML Validator v4"; ValueName: "InstallDirV60"; ValueType: String; ValueData: "{app}"; 
Root: HKCU; Subkey: "Software\AI Internet Solutions\CSE HTML Validator v4"; ValueName: "ValidatorEXE"; ValueType: String; ValueData: "cmdlineprocessor.exe"; 
Root: HKCU; Subkey: "Software\AI Internet Solutions\CSE HTML Validator v4"; ValueName: "EditorEXE"; ValueType: String; ValueData: "cse60.exe"; 
Root: HKLM; Subkey: "SOFTWARE\Alsoft\CSE 3310 HTML Validator"; ValueName: "HomeSiteCapability"; ValueType: String; ValueData: "5"; Flags: noerror 
Root: HKLM; Subkey: "SOFTWARE\Alsoft\CSE 3310 HTML Validator"; ValueName: "ExternalCapability"; ValueType: String; ValueData: "5"; Flags: noerror 
Root: HKLM; Subkey: "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\htmlval.exe"; ValueName: "Path"; ValueType: String; ValueData: "{app}\cmdlineprocessor.exe"; Flags: noerror 
Root: HKLM; Subkey: "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\htmlval.exe"; ValueType: String; ValueData: "{app}\cmdlineprocessor.exe"; Flags: noerror 
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\cse60.exe"; Flags: noerror 
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\cse60.exe"; ValueType: String; ValueData: "{app}\cse60.exe"; Flags: noerror 
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\cse60.exe"; ValueName: "Path"; ValueType: String; ValueData: "{app}\cse60.exe"; Flags: noerror 
Root: HKU; Subkey: ".DEFAULT\Software\AI Internet Solutions\CSE HTML Validator v4"; ValueName: "InstallDir"; ValueType: String; ValueData: "{app}"; Flags: noerror 
Root: HKU; Subkey: ".DEFAULT\Software\AI Internet Solutions\CSE HTML Validator v4"; ValueName: "InstallDirV60"; ValueType: String; ValueData: "{app}"; Flags: noerror 
Root: HKU; Subkey: ".DEFAULT\Software\AI Internet Solutions\CSE HTML Validator v4"; ValueName: "ValidatorEXE"; ValueType: String; ValueData: "cmdlineprocessor.exe"; Flags: noerror 
Root: HKU; Subkey: ".DEFAULT\Software\AI Internet Solutions\CSE HTML Validator v4"; ValueName: "EditorEXE"; ValueType: String; ValueData: "cse60.exe"; Flags: noerror 

[Run]
Filename: "{app}\cse60.exe"; Description: "Launch CSE HTML Validator"; Flags: postinstall skipifsilent nowait

[UninstallRun]
Filename: "{app}\cmdlineprocessor.exe"; Parameters: "-x"; 

[Icons]
Name: "{group}\CSE HTML Validator Pro v6.0"; Filename: "{app}\cse60.exe"; WorkingDir: "{app}"; Comment: "Check HTML, XHTML, and CSS documents for syntax problems, broken links, and misspellings by using CSE HTML Validator."; 
Name: "{group}\License Agreement"; Filename: "{app}\license.txt"; Comment: "See the license agreement for CSE HTML Validator."; 
Name: "{group}\CSE HTML Validator Home Page"; Filename: "{app}\CSE HTML Validator Home Page.url"; Comment: "Launch your default browser and go to CSE HTML Validator's Home Page."; 
Name: "{group}\Ordering Information"; Filename: "{app}\Ordering Information.url"; Comment: "Launch your default browser and go to CSE HTML Validator's Ordering Page to purchase a license."; 
Name: "{group}\Uninstall CSE HTML Validator Pro v6.0"; Filename: "{uninstallexe}"; Comment: "Uninstall CSE HTML Validator Pro v6.0."; 
Name: "{userdesktop}\CSE HTML Validator Pro v6.0"; Filename: "{app}\cse60.exe"; WorkingDir: "{app}"; Comment: "Check HTML, XHTML, and CSS documents for syntax problems, broken links, and misspellings by using CSE HTML Validator."; Tasks: desktopicon; 
Name: "{userappdata}\Microsoft\Internet Explorer\Quick Launch\CSE HTML Validator Pro v6.0"; Filename: "{app}\cse60.exe"; WorkingDir: "{app}"; Comment: "Check HTML, XHTML, and CSS documents for syntax problems, broken links, and misspellings by using CSE HTML Validator."; Tasks: quicklaunchicon; 

[Tasks]
Name: "desktopicon"; Description: "Create a &desktop icon"; GroupDescription: "Additional icons:"; 
Name: "quicklaunchicon"; Description: "Create a &Quick Launch icon"; GroupDescription: "Additional icons:"; 
