//Language: Java
//Copyright (c) 1992-2002 Altium Limited             
//All rights reserved.                               
//http://www.dream-com.com                           
//contact@dream-com.com                              

// states
State=snormal,CaseSensitive
State=sstring1
State=sstring2
State=scomment1
State=scomment2
// tokens
Token=tnone
Token=tstring
Token=tcomment
Token=tident
Token=tinteger
Token=tfloat
Token=tresword
Token=tassembler
Token=turl
Token=twhitespace
//delims
Delimiters=;.,:'"{}[]()?!@#$%^&*-+=|\/

// reswords
snormal 'abstract'     snormal tresword
snormal 'boolean'      snormal tresword
snormal 'break'        snormal tresword
snormal 'byte'         snormal tresword
snormal 'case'         snormal tresword
snormal 'catch'        snormal tresword
snormal 'char'         snormal tresword
snormal 'class'        snormal tresword
snormal 'const'        snormal tresword
snormal 'continue'     snormal tresword
snormal 'default'      snormal tresword
snormal 'do'           snormal tresword
snormal 'double'       snormal tresword
snormal 'else'         snormal tresword
snormal 'extends'      snormal tresword
snormal 'false'        snormal tresword
snormal 'final'        snormal tresword
snormal 'finally'      snormal tresword
snormal 'float'        snormal tresword
snormal 'for'          snormal tresword
snormal 'goto'         snormal tresword
snormal 'if'           snormal tresword
snormal 'implements'   snormal tresword
snormal 'import'       snormal tresword
snormal 'instanceof'   snormal tresword
snormal 'int'          snormal tresword
snormal 'interface'    snormal tresword
snormal 'long'         snormal tresword
snormal 'native'       snormal tresword
snormal 'new'          snormal tresword
snormal 'null'         snormal tresword
snormal 'package'      snormal tresword
snormal 'private'      snormal tresword
snormal 'protected'    snormal tresword
snormal 'public'       snormal tresword
snormal 'return'       snormal tresword
snormal 'short'        snormal tresword
snormal 'static'       snormal tresword
snormal 'super'        snormal tresword
snormal 'switch'       snormal tresword
snormal 'synchronized' snormal tresword
snormal 'this'         snormal tresword
snormal 'throw'        snormal tresword
snormal 'throws'       snormal tresword
snormal 'transient'    snormal tresword
snormal 'true'         snormal tresword
snormal 'try'          snormal tresword
snormal 'void'         snormal tresword
snormal 'volatile'     snormal tresword
snormal 'while'        snormal tresword

// numbers
snormal [0-9][0-9]*                            snormal  tinteger
snormal 0X[0-9A-F]+                            snormal  tinteger
snormal [1-9][0-9]*\.[0-9]*                    snormal  tfloat
snormal [1-9][0-9]*{\.[0-9]+}|e{[\+\-]}|[0-9]+ snormal  tfloat
//idents
snormal   [a-z_A-Z][a-z_A-Z0-9]*  snormal   tident

//white space
snormal #32*                      snormal   twhitespace


//strings
snormal    \'                     sstring1   tstring
sstring1   [^\']*                 sstring1   tstring
sstring1   \'                     snormal    tstring
sstring1   \'\'                   sstring1   tstring
sstring1   \\                     sstring1   tstring
sstring1   \\\'                   sstring1   tstring
sstring1   $                      snormal    tstring

//strings
snormal     \"                    sstring2   tstring
sstring2   [^\"]*                 sstring2   tstring
sstring2   \"                     snormal    tstring
sstring2   \"\"                   sstring2   tstring
sstring2   \\                     sstring2   tstring
sstring2   \\\"                   sstring2   tstring
sstring2   $                      snormal    tstring


//comments
snormal   //                      scomment1 tcomment
scomment1 [#1-#255]*              snormal   tcomment
scomment1 $                       snormal   tcomment

snormal   /\*                     scomment2 tcomment
scomment2 [^\*]*                  scomment2 tcomment
scomment2 \*[^/]                  scomment2 tcomment
scomment2 [\*]*/                  snormal   tcomment
