//Language: Oberon
//Copyright (c) 1992-2002 Altium Limited             
//All rights reserved.                               
//http://www.dream-com.com                           
//contact@dream-com.com                              

// states
State=snormal
State=sstring
State=scomment
// tokens
Token=tnone
Token=tstring
Token=tcomment
Token=tident
Token=tinteger
Token=tfloat
Token=tresword
Token=tassembler
Token=turl
Token=twhitespace
//delims
Delimiters=;.,:'"{}[]()?!@#$%^&*-+=|\/

// reswords
snormal 'ARRAY'     snormal tresword
snormal 'BEGIN'     snormal tresword
snormal 'CASE'      snormal tresword
snormal 'CONST'     snormal tresword
snormal 'DIV'       snormal tresword
snormal 'DO'        snormal tresword
snormal 'ELSE'      snormal tresword
snormal 'ELSIF'     snormal tresword
snormal 'END'       snormal tresword
snormal 'EXIT'      snormal tresword
snormal 'IF'        snormal tresword
snormal 'IMPORT'    snormal tresword
snormal 'IN'        snormal tresword
snormal 'IS'        snormal tresword
snormal 'LOOP'      snormal tresword
snormal 'MOD'       snormal tresword
snormal 'MODULE'    snormal tresword
snormal 'NIL'       snormal tresword
snormal 'OF'        snormal tresword
snormal 'OR'        snormal tresword
snormal 'POINTER'   snormal tresword
snormal 'PROCEDURE' snormal tresword
snormal 'RECORD'    snormal tresword
snormal 'REPEAT'    snormal tresword
snormal 'RETURN'    snormal tresword
snormal 'THEN'      snormal tresword
snormal 'TO'        snormal tresword
snormal 'TYPE'      snormal tresword
snormal 'UNTIL'     snormal tresword
snormal 'VAR'       snormal tresword
snormal 'WHILE'     snormal tresword
snormal 'WITH'      snormal tresword

 // numbers
snormal [0-9][0-9]*                            snormal  tinteger
snormal [1-9][0-9]*\.[0-9]*                    snormal  tfloat
snormal [1-9][0-9]*{\.[0-9]+}|e{[\+\-]}|[0-9]+ snormal  tfloat

//idents
snormal   [a-z_A-Z][a-z_A-Z0-9]*  snormal   tident

//white space
snormal #32*                      snormal   twhitespace

//strings
snormal   \"                     sstring   tstring
sstring   [^\"]*                 sstring   tstring
sstring   \"                     snormal    tstring
sstring   \"\"                   sstring   tstring
sstring   $                      snormal    tstring


//comments
snormal   (\*                     scomment tcomment 
scomment  [^\*]*                  scomment tcomment
scomment  \*[^)]                  scomment tcomment
scomment  [\*]*)                  snormal  tcomment
